Attribute VB_Name = "Module1"
Option Explicit
' 2003 Roger Gilchrist <rojagilkrist@hotmail.com>
'based on the VBhelper upload 'howto_validate_date.zip'
'This code internationalises it to work with
'whatever your local date format and date divisor are.
'Also includes a way of coping with
'ASCII/UniCode data (pre-Win2K or post-Win2K)
'
'Unless you have access to machines using different date systems
'or feel like fiddling with your machine's regional settings
'you'll have to take this on faith ;)
'
Private Const LOCALE_SDATE           As Long = &H1D   ' get the date divisor
Private Const LOCALE_ILDATE          As Long = &H22   ' get the long DMY order
Private Const LOCALE_IDATE           As Long = &H21   ' get the DMY order
Private Const LOCALE_SSHORTDATE      As Long = &H1F   ' get the short date
Private Const LOCALE_SLONGDATE       As Long = &H20   ' get the long date format
'You can find many other localisation constants
'in VB help under 'Locale Information ' No values but lots of explanations
'or in API viewer search for 'LOCALE_' ' No explanations but has values
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, _
                                                                              ByVal LCType As Long, _
                                                                              ByVal lpLCData As String, _
                                                                              ByVal cchData As Long) As Long

Private Function InputDateFormat() As String

  'this creates the date format to check with Format in IsValidDate

  Select Case LocalDMY
   Case 0
    InputDateFormat = "m" & LocalDateDiv & "d" & LocalDateDiv & "yy"
   Case 1
    InputDateFormat = "d" & LocalDateDiv & "m" & LocalDateDiv & "yy"
   Case 2
    InputDateFormat = "yy" & LocalDateDiv & "m" & LocalDateDiv & "d"
  End Select

End Function

Public Function IsValidDate(ByVal txt As String, _
                            Optional strFormat As String) As Boolean

  'internationalized version
  'Optionally returns the format that it recognised
  'otherwise for days whose number is < 12 you may not be sure
  'if 2/12/99 is 2nd December or 12th Febuary if you don't
  'know which system your machine is using

  strFormat = InputDateFormat
  On Error GoTo DoneChecking
  IsValidDate = (Format$(CDate(txt), strFormat) = txt)

Exit Function

DoneChecking:
  strFormat = "INVALID DATE: " & txt & " Check format = " & strFormat

End Function

Public Function LocalDateDiv() As String

  ' gets the local date divisor

  LocalDateDiv = LocalizationData(LOCALE_SDATE)

End Function

Public Function LocalDMY() As Integer

  'gets the D M Y order
  'Returns 0,1, or 2
  '0 Month-Day-Year
  '1 Day-Month-Year
  '2 Year-Month-Day

  LocalDMY = LocalizationData(LOCALE_ILDATE)
  'LocalDMY = LocalizationData(LOCALE_IDATE) would also work
  '(I can't imagine anyone uses different ones in a single local)

End Function

Public Function LocalizationData(ByVal LData As Long) As String

  'This is a general routine to read whatever bit of data
  'you want based on the constants fed to it as LData
  
  Dim stBuff As String * 255
  Dim Ret    As Long

  Ret = GetLocaleInfo(1024, LData, ByVal stBuff, Len(stBuff))
  If Ret Then
    LocalizationData = Left$(stBuff, Ret - IIf(StrConv(stBuff, vbFromUnicode) = stBuff, 0, 1))
    'NOTE the IIf bit of code determines whether you are dealing with an ASCII or UniCode system and
    'trims the string accordingly
  End If

End Function

Public Function LocalLongDate() As String

  LocalLongDate = LocalizationData(LOCALE_SLONGDATE)

End Function

Public Function LocalShortDate() As String

  LocalShortDate = LocalizationData(LOCALE_SSHORTDATE)

End Function


